<template>
  <page
    class="flex-grow-1"
    id="person-data-page"
    v-if="person"
    :title="person.fullname"
  >
    <person-data :person="person" />
    <v-divider />
    <v-subheader>Histórico</v-subheader>
    <v-timeline
      class="mb-5"
      dense="dense"
    >
      <v-timeline-item
        v-for="event in events"
        :key="event.id"
        :color="typeInfo(event).color"
      >
        <v-list-item
          justify="space-between"
          :to="typeInfo(event).to"
        >
          <v-list-item-content>
            <v-list-item-title>{{typeInfo(event).msg}}</v-list-item-title>
          </v-list-item-content>
          <v-col class="text-right">{{timeFromISO(event.created)}}</v-col>
        </v-list-item>
      </v-timeline-item>
    </v-timeline>
  </page>
</template>

<script>
import Page from '@/components/Page.vue'
import PersonData from '@/components/utils/PersonData.vue'
import { DateTime } from 'luxon'

import personInfoQuery from '@/gql/PersonInfo.gql'
import personInfoSubscription from '@/gql/PersonInfoSubscription.gql'

export default {
  name: 'PersonsPage',
  components: { Page, PersonData },
  data: () => ({}),
  computed: {
    id () {
      return this.$route.params.id
    },
    events () {
      const reversed = this.person.events.slice()
      reversed.reverse()

      return reversed
    }
  },
  apollo: {
    person: {
      query: personInfoQuery,
      variables () {
        return {
          id: this.id
        }
      },
      skip () {
        return !this.id
      },
      subscribeToMore: {
        document: personInfoSubscription,
        variables () {
          return {
            id: this.id
          }
        },
        skip () {
          return !this.id
        }
      }
    }
  },
  methods: {
    typeInfo (event) {
      switch (event.type) {
        case 'CREATED':
          return { msg: 'Pessoa registrada', color: 'success' }
        case 'ASSOCIATED':
          return {
            msg: `Código ${event.data && event.data.card.code} associado`,
            to: { name: 'card', params: { id: event.data.card.id } }
          }
        case 'UPDATED':
          return {
            msg: 'Pessoa atualizada'
          }
      }

      return {
        msg: `Unknown event type: ${event.type}`
      }
    },
    timeFromISO (time) {
      return DateTime.fromISO(time).toFormat('dd/MM/yyyy - TT')
    },
    openDialog (id) {
      this.dialogID = id
      this.infoDialog = true
    }
  }
}
</script>
